=== debian/changelog ===
vtk-dicom (0.8.14-3.2~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Steve Langasek <vorlon@debian.org>  Mon, 05 Feb 2024 16:46:05 +0000

vtk-dicom (0.8.14-3.1) unstable; urgency=medium

  * Non-maintainer upload
  * debian/control: Use ${python3:Depends} (Closes: #1029178)

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 21 Jan 2023 22:41:32 +0100

vtk-dicom (0.8.14-3) unstable; urgency=medium

  * Team upload.
  * d/t/python: Really fix name of the module

 -- Mathieu Malaterre <malat@debian.org>  Tue, 17 Jan 2023 14:58:40 +0100

vtk-dicom (0.8.14-2) unstable; urgency=medium

  * Team upload.
  * d/t/python: Fix name of the module

 -- Mathieu Malaterre <malat@debian.org>  Fri, 13 Jan 2023 09:33:12 +0100

vtk-dicom (0.8.14-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.8.14
  * d/patches: Refresh patches for new upstream
  * d/control: Add fake dependency to libvtk9-qt-dev

 -- Mathieu Malaterre <malat@debian.org>  Tue, 10 Jan 2023 08:05:26 +0100

vtk-dicom (0.8.13-2) unstable; urgency=medium

  * Team upload.
  * d/patches: Refresh patches
  * d/control: Bump Std-Vers to 4.6.2 no changes needed
  * d/control: Remove unneeded dependency

 -- Mathieu Malaterre <malat@debian.org>  Thu, 05 Jan 2023 11:45:48 +0100

vtk-dicom (0.8.13-1) experimental; urgency=medium

  * New upstream version 0.8.13
  * d/control: Switch to vtk9. Closes: #1013154
  * d/control: Run wrap-and-sort
  * d/*.install: Adapt to latest release change
  * d/control: Bump Std-Vers to 4.6.1 no changes needed

 -- Mathieu Malaterre <malat@debian.org>  Mon, 27 Jun 2022 15:57:43 +0200
