=== debian/control ===
Source: vtk-dicom
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Gert Wollny <gewo@debian.org>
Section: graphics
Priority: optional
Build-Depends: cmake,
               debhelper (>= 12~),
               dh-exec,
               dh-python,
               help2man,
               libgdcm-dev,
               libvtk9-dev,
               libvtk9-qt-dev,
               python3-dev,
               python3-vtk9,
               xauth,
               xvfb
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/vtk-dicom
Vcs-Git: https://salsa.debian.org/med-team/vtk-dicom.git
Homepage: http://github.com/dgobbi/vtk-dicom/
Testsuite: autopkgtest-pkg-python

Package: libvtk-dicom-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libvtkdicom0.8t64 (= ${binary:Version}), ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Breaks: libvtk-dicom0.7-dev, libvtkdicom0.7
Replaces: libvtk-dicom0.7-dev, libvtkdicom0.7
Description: DICOM for VTK - dev
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Development headers

Package: libvtkdicom0.8t64
Provides: ${t64:Provides}
Replaces: libvtkdicom0.8
Breaks: libvtkdicom0.8 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: DICOM for VTK - lib
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Libraries for runtime applications

Package: vtk-dicom-tools
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: DICOM for VTK - tools
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Command line tools

Package: python3-vtk-dicom
Architecture: any
Section: python
Depends: ${python3:Depends}, python3-vtk9, ${misc:Depends}, ${shlibs:Depends}
Provides: ${python3:Provides}
Description: DICOM for VTK - Python
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Python 3.x bindings
